Package com.orchestranetworks.hierarchy

# Interface HierarchyNode

public interface HierarchyNode
Represents a node in a hierarchy. A hierarchy node is either a record, an enumeration value, a technical node (root or a parent for orphans).

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Object`
  `getEnumerationValue()`
  Returns the current enumeration value if `isEnumerationNode()` is `true`; otherwise, returns `null`.
  `Adaptation`
  `getJoinOccurrence()`
  Returns the association record that links the current node with its parent.
  `Adaptation`
  `getOccurrence()`
  Returns the current record being displayed.
  `HierarchyNode`
  `getParentHierarchyNode()`
  Returns this node's parent node in the hierarchy.
  `boolean`
  `isEnumerationNode()`
  Returns `true` if the current node is an enumeration node.
  `boolean`
  `isOccurrenceNode()`
  Returns `true` if the current node is a table record node.
  `boolean`
  `isOrphansParent()`
  Returns `true` if the current node is the parent of an orphan.
  `boolean`
  `isRoot()`
  Returns `true` if the current node is the root of the hierarchy.
  `boolean`
  `isTarget()`
  Returns `true` if the current record is a record in the target table.
  `boolean`
  `isTerminal()`
  Returns `true` if the current node has no children in the hierarchy.

- ## Method Details

  - ### getParentHierarchyNode

    HierarchyNode getParentHierarchyNode()
    Returns this node's parent node in the hierarchy.

  - ### getOccurrence

    Adaptation getOccurrence()
    Returns the current record being displayed.

    Warning: if this node is an enumeration node, a root or an orphan's parent, this method returns `null`.

    See Also:
      - `getEnumerationValue()`

  - ### getJoinOccurrence

    Adaptation getJoinOccurrence()
    Returns the association record that links the current node with its parent.

    Warning: if this node is an enumeration node, a root or an orphan's parent, or if there is no join dependency between the node and its parent, this method returns `null`.

    See Also:
      - `getOccurrence()`

  - ### getEnumerationValue

    Object getEnumerationValue()
    Returns the current enumeration value if `isEnumerationNode()` is `true`; otherwise, returns `null`.
    See Also:
      - `getOccurrence()`

  - ### isEnumerationNode

    boolean isEnumerationNode()
    Returns `true` if the current node is an enumeration node. An enumeration corresponds to a `xs:enumeration` element in the data model.

    In this case, the method `getOccurrence()` returns `null`.

    See Also:
      - `getEnumerationValue()`

  - ### isOccurrenceNode

    boolean isOccurrenceNode()
    Returns `true` if the current node is a table record node.

    In this case, the method `getEnumerationValue()` returns `null`.

    See Also:
      - `getOccurrence()`

  - ### isOrphansParent

    boolean isOrphansParent()
    Returns `true` if the current node is the parent of an orphan.

    In this case, the method `getOccurrence()` returns `null`.

  - ### isRoot

    boolean isRoot()
    Returns `true` if the current node is the root of the hierarchy.

    In this case, the method `getOccurrence()` returns `null`.

  - ### isTarget

    boolean isTarget()
    Returns `true` if the current record is a record in the target table.

    The target table is the table from which the hierarchy was built.

  - ### isTerminal

    boolean isTerminal()
    Returns `true` if the current node has no children in the hierarchy.